﻿$adminSiteUrl = "https://mytenant-admin.sharepoint.com"
$themeName = "Rainbow Theme"
$cred = Get-Credential
Connect-SPOService $adminSiteUrl -Credential $cred

$palette = @{
# included in theme generator
"themePrimary" = "#e55342" #Strawberry 
"themeLighterAlt" = "#888EA8"; #Dark lavender
"themeLighter" = "#efe6f2"; #Light lavender
"themeLight" = "#796722"; #Olive
"themeTertiary" = "#994719"; #Sienna
"themeSecondary" = "#AD4361"; #Raspberry
"themeDarkAlt" = "#FBC0C3"; #Pink
"themeDark" = "#80B88C"; #Dark Mint
"themeDarker" = "#FFB29A"; #Light salmon
"neutralLighterAlt" = "#136D80"; #Teal
"neutralLighter" = "#e8fffd"; #Light turqoise
"neutralLight" = "#765A4F"; #Coffee
"neutralQuaternaryAlt" = "#8A5E72"; #Dark plum
"neutralQuaternary" = "#016d28"; #Pine
"neutralTertiaryAlt" = "#ffd9bf"; #Light orange
"neutralTertiary" = "#ffcc01"; #Yellow
"neutralSecondary" = "#9aabb2"; #Gray
"neutralPrimaryAlt" = "#9C000C"; #Maroon
"neutralPrimary" = "#53C7BD"; #Turqoise
"neutralDark" = "#F4843E"; #Orange
"black" = "#000000"; #Black
"white" = "#ffffff"; #White
# no longer included in theme generator
"primaryBackground" = "#FFF7D7"; #Light yellow
"primaryText" = "#72BD54"; #Lime
"bodyBackground" = "#ffbf40";
"bodyText" = "#593c00";
"disabledBackground" = "#CD9D7C";
"disabledText" = "#52834C";
# never been included in theme generator
"backgroundOverlay" = "#102542"; #Navy
"whiteTranslucent40" = "rgba(255,255,255,.4)"; #White translucent
"accent" = "#f87060"; #Coral
"accentButtonBackground" = "#990000";
"accentButtonText" = "#b25959";
"actionLink" = "#6f6f6f";
"actionLinkHovered" = "#4f4f4f";
"backgroundImageUri" = "";
"blackTranslucent40" = "#4a2d59";
"blockingBackground" = "#8d00d9";
"bodyDivider" = "#eaeaea";
"bodyFrameBackground" = "#8c8169";
"bodyFrameDivider" = "#005e8c";
"bodyStandoutBackground" = "#f8f8f8";
"bodySubtext" = "#F2C976";
"bodyTextChecked" = "#383040";
"buttonBackground" = "#2e0059";
"buttonBackgroundChecked" = "#c8c8c8";
"buttonBackgroundCheckedHovered" = "#39ace6";
"buttonBackgroundDisabled" = "#7999f2";
"buttonBackgroundHovered" = "#00138c";
"buttonBackgroundPressed" = "#7340ff";
"buttonBorder" = "#070059";
"buttonBorderDisabled" = "#b6c9f2";
"buttonText" = "#b27d59";
"buttonTextChecked" = "#4d6661";
"buttonTextCheckedHovered" = "#3e3e3e";
"buttonTextDisabled" = "#e2e2e2";
"buttonTextHovered" = "#00a7b3";
"buttonTextPressed" = "#003033";
"defaultStateBackground" = "#bffbff";
"dialogBorder" = "#b6c6f2";
"disabledBodySubtext" = "#f032e6";
"disabledBodyText" = "#911eb4";
"disabledSubtext" = "#d0d0d0";
"errorBackground" = "#164659";
"errorText" = "#a80000";
"focusBorder" = "#1d1040";
"inputBackground" = "#f2e200";
"inputBackgroundChecked" = "#4363d8";
"inputBackgroundCheckedHovered" = "#735656";
"inputBorder" = "#42d4f4";
"inputBorderHovered" = "#332f26";
"inputFocusBorderAlt" = "#9f59b3";
"inputForegroundChecked" = "#b8d9a3";
"inputPlaceholderText" = "#8c235d";
"inputText" = "#698c23";
"inputTextHovered" = "#59468c";
"link" = "#bfef45";
"linkHovered" = "#193a68";
"listBackground" = "#a9a9a9";
"listHeaderBackgroundHovered" = "#f4f4f4";
"listHeaderBackgroundPressed" = "#ca79f2";
"listItemBackgroundChecked" = "#ff00ee";
"listItemBackgroundCheckedHovered" = "#dadada";
"listItemBackgroundHovered" = "#ff8093";
"listText" = "#95e639";
"listTextColor" = "#073300";
"menuBackground" = "#fabebe";
"menuDivider" = "#401024";
"menuHeader" = "#ffe119";
"menuIcon" = "#f58231";
"menuItemBackgroundChecked" = "#4d1341";
"menuItemBackgroundHovered" = "#000075";
"menuItemBackgroundPressed" = "#e6acda";
"menuItemText" = "#008c4b";
"menuItemTextHovered" = "#59000c";
"neutralSecondaryAlt" = "#767676";
"primaryButtonBackground" = "#a60003";
"primaryButtonBackgroundDisabled" = "#469990";
"primaryButtonBackgroundHovered" = "#401d10";
"primaryButtonBackgroundPressed" = "#ff6600";
"primaryButtonBorder" = "#00e6cb";
"primaryButtonText" = "#e6beff";
"primaryButtonTextDisabled" = "#ff0048";
"primaryButtonTextHovered" = "#ffd8b1";
"primaryButtonTextPressed" = "#aaffc3";
"smallInputBorder" = "#9A6324";
"successBackground" = "#003312";
"suiteBarBackground" = "#800000";
"suiteBarDisabledText" = "#b32d86";
"suiteBarText" = "#fffac8";
"topBarBackground" = "#331a27";
"topBarHoverText" = "#40ffbf";
"topBarText" = "#808000";
"variantBorder" = "#ff0022";
"variantBorderHovered" = "#ff4073";
"warningBackground" = "#1d7324";
"warningHighlight" = "#f2b6be";
"warningText" = "#333333";
# set colors
"yellow" = "#ffb900";
"yellowLight" = "#fff100";
"orange" = "#d83b01";
"orangeLight" = "#ea4300";
"orangeLighter" = "#ff8c00";
"red" = "#e81123";
"redDark" = "#8c6973";
"magenta" = "#b4009e";
"magentaDark" = "#5c005c";
"magentaLight" = "#e3008c";
"purple" = "#5c2d91";
"purpleDark" = "#32145a";
"purpleLight" = "#b4a0ff";
"blue" = "#0078d4";
"blueDark" = "#002050";
"blueLight" = "#00bcf2";
"blueMid" = "#00188f";
"teal" = "#008272";
"tealDark" = "#004b50";
"tealLight" = "#00b294";
"green" = "#107c10";
"greenDark" = "#004b1c";
"greenLight" = "#bad80a";
}
# For an existing theme to get updated, it needs to be removed and re-added
try {
    Remove-SPOTheme -name $themeName
}
catch {
    # first time adding theme
}

Add-SPOTheme -Name $themeName -Palette $palette -IsInverted:$false